using System;

//-----------------------------------------------
//      
//    XML
//-----------------------------------------------
public class SaveAndLoadXML_UseDOM
{
  //XML-,       
  const string XML_ROOT_TAG = "AllMyData";
  const string XML_USERINFO_TAG = "UserInfo";
  const string XML_USERID_TAG = "UserID";
  const string XML_NAMEINFO_TAG = "Name";
  const string XML_FIRSTNAME_TAG = "FirstName";
  const string XML_LASTNAME_TAG = "LastName";

  //----------------------------------------------------------------
  //  
  //
  // [in] fileName:    ,    
  // [out] userId:      
  // [out] firstName:   
  // [out] lastName:    
  //----------------------------------------------------------------
  public static void XML_LoadUserInfo(string fileName, 
    out int userId, out string firstName, out string lastName)
  {
    //   
    userId = 0;
    firstName = "";
    lastName = "";
    //,     
    bool gotUserInfoData = false; 

    System.Xml.XmlDocument xmlDocument = 
      new System.Xml.XmlDocument();

    xmlDocument.Load(fileName);

    //  
    System.Xml.XmlElement rootElement;
    rootElement = 
      (System.Xml.XmlElement) xmlDocument.ChildNodes[0];

    //  ,       ,
    //  ,      -  XML-
    if (rootElement.Name != XML_ROOT_TAG)
    {
      throw new Exception("      !");
    }

    //-----------------------------------------------------------
    //       
    //-----------------------------------------------------------
    foreach(System.Xml.XmlElement childOf_RootNode in 
      rootElement.ChildNodes)
    {

      //   UserInfo,      
      if(childOf_RootNode.Name == XML_USERINFO_TAG)
      {
        gotUserInfoData  = true; //  

        //--------------------------------------
        //   
        //--------------------------------------
        foreach(System.Xml.XmlElement child_UserDataNode in 
          childOf_RootNode.ChildNodes)
        {
          //  (UserID)
          if(child_UserDataNode.Name == XML_USERID_TAG)
          {
            userId	= System.Convert.ToInt32(
              child_UserDataNode.InnerText);
          }
            //  (UserName)
          else if(child_UserDataNode.Name == XML_NAMEINFO_TAG)
          {
            foreach(System.Xml.XmlElement child_Name in 
              child_UserDataNode.ChildNodes)
            {
              // (FirstName)
              if(child_Name.Name == XML_FIRSTNAME_TAG)
              {
                firstName = child_Name.InnerText;
              }
                // (LastName)
              else if(child_Name.Name == XML_LASTNAME_TAG)
              {
                lastName = child_Name.InnerText;
              }

            } //   UserName
          } //  if,   UserName

        }//   UserInfo
      }   if,   UserInfo

    }//    

    if (gotUserInfoData == false)
    {
      throw new Exception("   XML-  !");
    }

  }

  //-----------------------------------------------------------------------
  //  
  //
  // [in] fileName:   ,    
  // [in] userId:     ,    
  // [in] firstName:  ,    
  // [in] lastName:   ,    
  //-----------------------------------------------------------------------
  public static void XML_SaveUserInfo(string fileName, 
    int userId, string firstName, string lastName)
  {

    System.Xml.XmlDocument xmlDocument = 
      new System.Xml.XmlDocument();

    //---------------------------------------------------------
    //    
    //---------------------------------------------------------
    System.Xml.XmlElement rootNodeForDocument;
    rootNodeForDocument = xmlDocument.CreateElement(
      XML_ROOT_TAG);
    xmlDocument.AppendChild(rootNodeForDocument);

    //---------------------------------------------------------
    //    UserInfo
    //---------------------------------------------------------
    System.Xml.XmlElement topNodeForUserData;
    topNodeForUserData = xmlDocument.CreateElement(
      XML_USERINFO_TAG);
    rootNodeForDocument.AppendChild(topNodeForUserData);


    //---------------------------------------------------------
    //  UserID   
    //---------------------------------------------------------
    //      
    System.Xml.XmlElement subNodeForUserID;
    subNodeForUserID = 
      xmlDocument.CreateElement(XML_USERID_TAG);
    subNodeForUserID.InnerText = 
      System.Convert.ToString(userId);
    //  UserID    
    topNodeForUserData.AppendChild(subNodeForUserID);


    //---------------------------------------------------------
    //   NameInfo   
    //---------------------------------------------------------
    //      
    System.Xml.XmlElement subNodeForNameInfo;
    subNodeForNameInfo = xmlDocument.CreateElement(
      XML_NAMEINFO_TAG);
    // (FirstName)
    System.Xml.XmlElement subNodeFirstName;
    subNodeFirstName = xmlDocument.CreateElement(
      XML_FIRSTNAME_TAG);
    subNodeFirstName.InnerText = firstName;

    // (LastName)
    System.Xml.XmlElement subNodeLastName;
    subNodeLastName = xmlDocument.CreateElement(
      XML_LASTNAME_TAG);
    subNodeLastName.InnerText = lastName;

    //       
    // NameInfo
    subNodeForNameInfo.AppendChild(subNodeFirstName);
    subNodeForNameInfo.AppendChild(subNodeLastName);

    //  NameInfo (    )
    //   
    topNodeForUserData.AppendChild(subNodeForNameInfo);


    //---------------------------------------------------------
    // 
    //---------------------------------------------------------
    try
    {
      xmlDocument.Save(fileName);
    }
    catch (System.Exception ex)
    {
      System.Windows.Forms.MessageBox.Show(
        "   XML- - " + ex.Message);
    }
  } // 
} // 
