Option Strict On
Option Compare Binary
Imports System

'-----------------------------------------------
'      
'    XML
'-----------------------------------------------
Public Class SaveAndLoadXML_UseDOM
  'XML-,       
  Const XML_ROOT_TAG As String = "AllMyData"
  Const XML_USERINFO_TAG As String = "UserInfo"
  Const XML_USERID_TAG As String = "UserID"
  Const XML_NAMEINFO_TAG As String = "Name"
  Const XML_FIRSTNAME_TAG As String = "FirstName"
  Const XML_LASTNAME_TAG As String = "LastName"

'----------------------------------------------------------------
'  
'
' [in] fileName:    ,    
' [out] userId:      
' [out] firstName:   
' [out] lastName:    
'----------------------------------------------------------------
Public Shared Sub XML_LoadUserInfo(ByVal fileName As String, _
  ByRef userId As Integer, ByRef firstName As String, _
  ByRef lastName As String)

  '   
  userId = 0
  firstName = ""
  lastName = ""
  ',     
  Dim gotUserInfoData As Boolean = False

  Dim xmlDocument As System.Xml.XmlDocument = _
      New System.Xml.XmlDocument

  xmlDocument.Load(fileName)

  '  
  Dim rootElement As System.Xml.XmlElement
  rootElement = _
    CType(xmlDocument.ChildNodes(0), System.Xml.XmlElement)

  '  ,       ,
  '  ,      -  XML-
  If (rootElement.Name <> XML_ROOT_TAG) Then
        Throw New Exception("      !")
  End If

  '-----------------------------------------------------------
  '       
  '-----------------------------------------------------------
  Dim childOf_RootNode As System.Xml.XmlElement
  For Each childOf_RootNode In _
          rootElement.ChildNodes

    '   UserInfo,      
    If (childOf_RootNode.Name = XML_USERINFO_TAG) Then
            gotUserInfoData = True '  

      '--------------------------------------
      '   
      '--------------------------------------
      Dim child_UserDataNode As System.Xml.XmlElement
      For Each child_UserDataNode In _
              childOf_RootNode.ChildNodes
                '  (UserID)
        If (child_UserDataNode.Name = XML_USERID_TAG) Then
            userId = CInt(child_UserDataNode.InnerText)
          '  (UserName)
        ElseIf (child_UserDataNode.Name = XML_NAMEINFO_TAG) Then
          Dim child_Name As System.Xml.XmlElement
          For Each child_Name In child_UserDataNode.ChildNodes
            ' (FirstName)
            If (child_Name.Name = XML_FIRSTNAME_TAG) Then
              firstName = child_Name.InnerText
            ' (LastName)
            ElseIf (child_Name.Name = XML_LASTNAME_TAG) Then
              lastName = child_Name.InnerText
            End If

          Next '   UserName
        End If '  if,   UserName

      Next '   UserInfo
    End If '  if,   UserInfo

  Next  '    

  If (gotUserInfoData = False) Then
        Throw New Exception("   XML-  !")
  End If
End Sub

'-----------------------------------------------------------
'  
'
' [in] fileName:   ,    
' [in] userId:     ,    
' [in] firstName:  ,    
' [in] lastName:   ,    
'-----------------------------------------------------------
Public Shared Sub XML_SaveUserInfo(ByVal fileName As String, _
  ByVal userId As Integer, ByVal firstName As String, _
  ByVal lastName As String)

  Dim xmlDocument As System.Xml.XmlDocument = _
                      New System.Xml.XmlDocument

  '---------------------------------------------------------
  '    
  '---------------------------------------------------------
  Dim rootNodeForDocument As System.Xml.XmlElement
  rootNodeForDocument = xmlDocument.CreateElement( _
                            XML_ROOT_TAG)
  xmlDocument.AppendChild(rootNodeForDocument)

  '---------------------------------------------------------
  '    UserInfo
  '---------------------------------------------------------
  Dim topNodeForUserData As System.Xml.XmlElement
  topNodeForUserData = xmlDocument.CreateElement( _
                            XML_USERINFO_TAG)
  rootNodeForDocument.AppendChild(topNodeForUserData)

  '---------------------------------------------------------
  '  UserID   
  '---------------------------------------------------------
  '       
  Dim subNodeForUserID As System.Xml.XmlElement
  subNodeForUserID = _
      xmlDocument.CreateElement(XML_USERID_TAG)
  subNodeForUserID.InnerText = _
      System.Convert.ToString(userId)
  '  UserID    
  topNodeForUserData.AppendChild(subNodeForUserID)


  '---------------------------------------------------------
  '   NameInfo   
  '---------------------------------------------------------
  '      
  Dim subNodeForNameInfo As System.Xml.XmlElement
  subNodeForNameInfo = xmlDocument.CreateElement( _
                              XML_NAMEINFO_TAG)
  ' (FirstName)
  Dim subNodeFirstName As System.Xml.XmlElement
  subNodeFirstName = xmlDocument.CreateElement( _
                              XML_FIRSTNAME_TAG)
  subNodeFirstName.InnerText = firstName

  ' (LastName)
  Dim subNodeLastName As System.Xml.XmlElement
  subNodeLastName = xmlDocument.CreateElement( _
                              XML_LASTNAME_TAG)
  subNodeLastName.InnerText = lastName

  '        
  'NameInfo
  subNodeForNameInfo.AppendChild(subNodeFirstName)
  subNodeForNameInfo.AppendChild(subNodeLastName)

  '  NameInfo (    )
  '   
  topNodeForUserData.AppendChild(subNodeForNameInfo)


  '---------------------------------------------------------
  ' 
  '---------------------------------------------------------
  Try
        xmlDocument.Save(fileName)
  Catch ex As System.Exception
        MsgBox( _
      "   XML- - " + ex.Message)
  End Try
End Sub     ' 
End Class ' 
