Option Strict On
Option Compare Binary
Imports System
Public Class SaveAndLoadXML_UseReaderWriter

'XML-,       
Const XML_ROOT_TAG As String = "AllMyData"
Const XML_USERINFO_TAG As String = "UserInfo"
Const XML_USERID_TAG As String = "UserID"
Const XML_NAMEINFO_TAG As String = "Name"
Const XML_FIRSTNAME_TAG As String = "FirstName"
Const XML_LASTNAME_TAG As String = "LastName"

' ,     
Private Enum ReadLocation
  inAllMyData
  inUserInfo
  inUserID
  inName
  inFirstName
  inLastName
End Enum

'-----------------------------------------------------------
'  
'
' [in] fileName:   ,    
' [in] userId:     ,    
' [in] firstName:  ,    
' [in] lastName:   ,    
'-----------------------------------------------------------
Public Shared Sub XML_SaveUserInfo(ByVal fileName As String, _
  ByVal userId As Integer, ByVal firstName As String, _
  ByVal lastName As String)

  Dim xmlTextWriter As System.Xml.XmlTextWriter
  xmlTextWriter = New System.Xml.XmlTextWriter(fileName, _
                      System.Text.Encoding.Default)

  '  !
  '<Root>
  xmlTextWriter.WriteStartElement(XML_ROOT_TAG)

  '<Root>
  xmlTextWriter.WriteStartElement(XML_USERINFO_TAG)
  '<Root><UserID>

  '<Root><UserInfo>		
  xmlTextWriter.WriteStartElement(XML_NAMEINFO_TAG)
  '<Root><UserInfo><Name>		
  xmlTextWriter.WriteStartElement(XML_FIRSTNAME_TAG)
  '<Root><UserInfo><Name><FirstName>
  xmlTextWriter.WriteString(firstName) ' 
  xmlTextWriter.WriteEndElement() '  
  '<Root><UserInfo><Name>
  xmlTextWriter.WriteStartElement(XML_LASTNAME_TAG)
  '<Root><UserInfo><Name><LastName>
  xmlTextWriter.WriteString(lastName) ' 
  xmlTextWriter.WriteEndElement() '  
  '<Root><UserInfo><Name>
  xmlTextWriter.WriteEndElement() '  
  '<Root><UserInfo>

  '<Root><UserInfo>
  xmlTextWriter.WriteStartElement(XML_USERID_TAG)
  '<Root><UserInfo><UserID>

  ' 
  xmlTextWriter.WriteString(userId.ToString())
  xmlTextWriter.WriteEndElement()   UserID
  '<Root><UserInfo>

  xmlTextWriter.WriteEndElement() '  UserInfo
  '<Root>

  xmlTextWriter.WriteEndElement() '  

  xmlTextWriter.Close()
End Sub

'----------------------------------------------------------------
'  
'
' [in] fileName:    ,    
' [out] userId:      
' [out] firstName:   
' [out] lastName:    
'----------------------------------------------------------------
Public Shared Sub XML_LoadUserInfo(ByVal fileName As String, _
  ByRef userId As Integer, ByRef firstName As String, _
  ByRef lastName As String)

  Dim currentReadLocation As ReadLocation

  '   
  userId = 0
  firstName = ""
  lastName = ""


  Dim xmlReader As System.Xml.XmlTextReader = _
        New System.Xml.XmlTextReader(fileName)

  xmlReader.WhitespaceHandling = _
      System.Xml.WhitespaceHandling.None

  Dim readSuccess As Boolean

  readSuccess = xmlReader.Read()
  If (readSuccess = False) Then
        Throw New System.Exception(" XML-  !")
  End If

  '  ,     
  If (xmlReader.Name <> XML_ROOT_TAG) Then
        Throw New System.Exception( _
              "    !")
  End If

  '    
  currentReadLocation = ReadLocation.inAllMyData

  '------------------------------------------------------
  '      
  '------------------------------------------------------
  While (readSuccess)

    Select Case (xmlReader.NodeType)
            '     
      Case System.Xml.XmlNodeType.Element

        Dim nodeName As String = xmlReader.Name
        LoadHelper_NewElementEncountered(nodeName, _
                  currentReadLocation)

        '--------------------------------------------------
        '      
        '  ,   
        '--------------------------------------------------
      Case System.Xml.XmlNodeType.Text

        Select Case currentReadLocation
          Case ReadLocation.inFirstName
            firstName = xmlReader.Value

          Case ReadLocation.inLastName
            lastName = xmlReader.Value

          Case ReadLocation.inUserID
            userId = CInt(xmlReader.Value)
        End Select

      '  Case "System.Xml.XmlNodeType.Text"

      '-----------------------------------------------------
      ',   
      '
      '
      '       
      '   ,    ,  
      '     
      '-----------------------------------------------------
      Case System.Xml.XmlNodeType.EndElement
        Dim continueParsing As Boolean
        continueParsing = LoadHelper_EndElementEncountered( _
                          currentReadLocation)

        If (continueParsing = False) Then
            GoTo finished_reading_wanted_data
        End If

      Case Else
        ' ,   XML-  , 
        '     XML-   
        '   
        MsgBox( _
          "  XML- " + xmlReader.Name)

    End Select '  Case,     
    ' XML-, 

    '   
    readSuccess = xmlReader.Read()
  End While

  '      ,   
  'XML- UserInfo,   XML-,   , 
  '-  
  Throw New Exception("   UserInfo  XML-!")

finished_reading_wanted_data:
    ' ,     !
    xmlReader.Close()
End Sub

'--------------------------------------------------------
' ,    
' ,     ,
'   
'--------------------------------------------------------
Private Shared Function LoadHelper_EndElementEncountered( _
              ByRef currentReadLocation As ReadLocation) _
              As Boolean

    Select Case (currentReadLocation)
      '    Name,   
      '   UserInfo
    Case ReadLocation.inName
      currentReadLocation = ReadLocation.inUserInfo

      '    FirstName,   
      '   Name
    Case ReadLocation.inFirstName
      currentReadLocation = ReadLocation.inName

      '    LastName,   
      '   Name
    Case ReadLocation.inLastName
      currentReadLocation = ReadLocation.inName

      '    UserID,   
      '   UserInfo
    Case ReadLocation.inUserID
      currentReadLocation = ReadLocation.inUserInfo

      '    UserInfo,    
      '     UserID, FirstName 
      ' LastName
      '
      '   ,      
      ',    !
    Case ReadLocation.inUserInfo
            Return False  '   
  End Select

  Return True ' 
End Function

Private Shared Sub LoadHelper_NewElementEncountered( _
        ByVal nodeName As String, _
        ByRef currentReadLocation As ReadLocation)

  '---------------------------------------------------------
  '    !
  '
  '    ,   ,
  '       
  '---------------------------------------------------------
  Select Case (currentReadLocation)
    '     AllMyData,    
    ' ,   
    Case (ReadLocation.inAllMyData)

      If (nodeName = XML_USERINFO_TAG) Then
        currentReadLocation = ReadLocation.inUserInfo
      End If

    '     UserInfo,   
    ' ,   
    Case (ReadLocation.inUserInfo)
        If (nodeName = XML_USERID_TAG) Then
          currentReadLocation = ReadLocation.inUserID

      ElseIf (nodeName = XML_NAMEINFO_TAG) Then
            currentReadLocation = ReadLocation.inName
      End If

    '     Name,    
    ' ,   
    Case (ReadLocation.inName)
      If (nodeName = XML_FIRSTNAME_TAG) Then
        currentReadLocation = ReadLocation.inFirstName

      ElseIf (nodeName = XML_LASTNAME_TAG) Then
        currentReadLocation = ReadLocation.inLastName
      End If
  End Select
End Sub
End Class
