//-----------------------------------------------------------------------------
// #1:      PerformanceSampling, 
//                   .   , 
//                     .
// #2:       Form,      
//                TreeView   Button,    
//                  xxx_Click.
//-----------------------------------------------------------------------------

// ,      
// TreeView 
const int NUMBER_ITEMS = 800;

//-------------------------------------------------------------------------
//   "Fill: Baseline"
//
//       
// TreeView
//-------------------------------------------------------------------------
private void UnOptimizedFill_Click(
                          object sender, System.EventArgs e)
{
  //      
     if (treeView1.Nodes.Count > 0)
   {
     treeView1.BeginUpdate();
     treeView1.Nodes.Clear(); 
     treeView1.EndUpdate(); 
     treeView1.Update();
    } 
   //     
   //  
   System.GC.Collect();

   // 
   PerformanceSampling.StartSample(0, "TreeViewPopulate");

   //    TreeView
   for(int i = 0; i < NUMBER_ITEMS ; i++)
   {
      treeView1.Nodes.Add("TreeItem" + i.ToString());
   }

   //    
   PerformanceSampling.StopSample(0);
   System.Windows.Forms.MessageBox.Show(
               PerformanceSampling.GetSampleDurationText(0));
}

//-------------------------------------------------------------------------
//   "Clear: Baseline"
//
//       
// TreeView
//-------------------------------------------------------------------------
private void UnOptimizedClear_Click(
                          object sender, System.EventArgs e)
{
   //      
   //  
   System.GC.Collect();

   // 
   PerformanceSampling.StartSample(1, "TreeViewClear");
   treeView1.Nodes.Clear();

   PerformanceSampling.StopSample(1);
   System.Windows.Forms.MessageBox.Show(
               PerformanceSampling.GetSampleDurationText(1));

}

//--------------------------------------------------
//   "Fill: BeginUpdate"
//
//,     BeginUpdate()
//--------------------------------------------------
private void UseBeginEndUpdateForFill_Click(
                            object sender, System.EventArgs e)
{

   //      
   if (treeView1.Nodes.Count > 0)
   {
     treeView1.BeginUpdate(); 
     treeView1.Nodes.Clear(); 
     treeView1.EndUpdate(); 
     treeView1.Update();
    } 
   //      
   //  
   System.GC.Collect();

   // 
   PerformanceSampling.StartSample(2, 
                                 "Populate - Use BeginUpdate");

   //    TreeView
   treeView1.BeginUpdate();
   for(int i = 0; i < NUMBER_ITEMS ; i++)
   {
      treeView1.Nodes.Add("TreeItem" + i.ToString());
   }
   treeView1.EndUpdate();

   //    
   PerformanceSampling.StopSample(2);
   System.Windows.Forms.MessageBox.Show(
                 PerformanceSampling.GetSampleDurationText(2));

}

//--------------------------------------------------------
//   "Clear: BeginUpdate"
//,     BeginUpdate()
//--------------------------------------------------------
private void UseBeginEndUpdateForClear_Click(
                        object sender, System.EventArgs e)
{
   //      
   //  
   System.GC.Collect();

   // 
   PerformanceSampling.StartSample(3, "Clear - Use BeginUpdate");

   treeView1.BeginUpdate();
   treeView1.Nodes.Clear();
   treeView1.EndUpdate();

   //    
   PerformanceSampling.StopSample(3);
   System.Windows.Forms.MessageBox.Show(
                 PerformanceSampling.GetSampleDurationText(3));

}

//--------------------------------------------
//   "Fill: Use Array"
//
//,    
//--------------------------------------------
private void FillArrayBeforeAttachingToTree_Click(
                    object sender, System.EventArgs e)
{
   //      
   if (treeView1.Nodes.Count > 0)
   {
     treeView1.BeginUpdate(); 
     treeView1.Nodes.Clear(); 
     treeView1.EndUpdate(); 
     treeView1.Update();
     } 
   //      
   //  
   System.GC.Collect();

   // 
   PerformanceSampling.StartSample(4, "Populate - Use Array");

   //      
   System.Windows.Forms.TreeNode [] newTreeNodes = 
      new System.Windows.Forms.TreeNode[NUMBER_ITEMS];

   // 
   for(int i = 0; i < NUMBER_ITEMS ; i++)
   {
      newTreeNodes[i] = 
       new System.Windows.Forms.TreeNode("TreeItem" + i.ToString());
   }

   //     TreeView
   treeView1.BeginUpdate();
   treeView1.Nodes.AddRange(newTreeNodes);
   treeView1.EndUpdate();

   //    
   PerformanceSampling.StopSample(4);
   System.Windows.Forms.MessageBox.Show(
               PerformanceSampling.GetSampleDurationText(4));
}
