Imports System
Imports System.Drawing

Friend Class GraphicsGlobals
  '=======================================================================
  ' 1:    
  '               .
  '
  '         ,
  '      
  '=======================================================================
Private Shared s_bluePen As Pen
Public Shared ReadOnly Property globalBluePen() As Pen
  Get
    '     
    If (s_bluePen Is Nothing) Then
      s_bluePen = New System.Drawing.Pen( _
                    System.Drawing.Color.Blue)
    End If
    Return s_bluePen
  End Get
End Property

  '=========================================================
  ' 2: 
  '    
  '  Pen, ImageAttribute, Font  Brush
  '
  '       , 
  '      .
  '=========================================================
Public Shared g_blackPen As Pen
Public Shared g_whitePen As Pen
Public Shared g_ImageAttribute As Imaging.ImageAttributes
Private Shared s_alreadyInitialized As Boolean
Public Shared g_boldFont As Font
Public Shared g_smallTextFont As Font
Public Shared g_greenBrush As Brush
Public Shared g_yellowBrush As Brush
Public Shared g_redBrush As Brush
Public Shared g_blackBrush As Brush

'==============================================================
'          
'  
'==============================================================
Public Shared Sub InitializeGlobals()
  If (s_alreadyInitialized = True) Then Return
  g_blackPen = New System.Drawing.Pen(Color.Black)
  g_whitePen = New System.Drawing.Pen(Color.White)
  g_ImageAttribute = New _
          System.Drawing.Imaging.ImageAttributes
  g_ImageAttribute.SetColorKey(Color.White, Color.White)
  g_boldFont = New Font(FontFamily.GenericSerif, _
                        10, FontStyle.Bold)
  g_smallTextFont = New Font(FontFamily.GenericSansSerif, _
                          8, FontStyle.Regular)

  g_blackBrush = New SolidBrush(System.Drawing.Color.Black)
  g_greenBrush = New SolidBrush( _
                          System.Drawing.Color.LightGreen)
  g_yellowBrush = New SolidBrush(System.Drawing.Color.Yellow)
  g_redBrush = New SolidBrush(System.Drawing.Color.Red)

  s_alreadyInitialized = True
End Sub

  '================================================================
  ' 3:    .
  '               ,   
  '                ()   
  '
  '================================================================
Private Shared m_CaveMan_Bitmap1 As Bitmap
Private Shared m_CaveMan_Bitmap2 As Bitmap
Private Shared m_CaveMan_Bitmap3 As Bitmap
Private Shared m_CaveMan_Bitmap4 As Bitmap
Private Shared m_colCaveManBitmaps As _
                  System.Collections.ArrayList

'----------------------------------------------------------
'      
'----------------------------------------------------------
Public Shared Function g_CaveManPictureCollection() As _
                              System.Collections.ArrayList

    '     ,      
  If (m_CaveMan_Bitmap1 Is Nothing) Then
      '-----------------------------------------------------------------
      ' .     
      '     
      '
      '       
      ',     (    
      '     ).
      '-----------------------------------------------------------------
      '     
    dim thisAssembly  as System.Reflection.Assembly = _
            System.Reflection.Assembly.GetExecutingAssembly()

    '  
    Dim thisAssemblyName As System.Reflection.AssemblyName = _
                                    thisAssembly.GetName()
    Dim assemblyName As String = thisAssemblyName.Name

    '        
    m_CaveMan_Bitmap1 = New System.Drawing.Bitmap( _
        thisAssembly.GetManifestResourceStream( _
        assemblyName + ".Hank_RightRun1.bmp"))

    m_CaveMan_Bitmap2 = New System.Drawing.Bitmap( _
          thisAssembly.GetManifestResourceStream( _
          assemblyName + ".Hank_RightRun2.bmp"))

    m_CaveMan_Bitmap3 = New System.Drawing.Bitmap( _
          thisAssembly.GetManifestResourceStream( _
          assemblyName + ".Hank_LeftRun1.bmp"))

    m_CaveMan_Bitmap4 = New System.Drawing.Bitmap( _
          thisAssembly.GetManifestResourceStream( _
          assemblyName + ".Hank_LeftRun2.bmp"))

    '   
    m_colCaveManBitmaps = New System.Collections.ArrayList
    m_colCaveManBitmaps.Add(m_CaveMan_Bitmap1)
    m_colCaveManBitmaps.Add(m_CaveMan_Bitmap2)
    m_colCaveManBitmaps.Add(m_CaveMan_Bitmap3)
    m_colCaveManBitmaps.Add(m_CaveMan_Bitmap4)
  End If

  ' 
  Return m_colCaveManBitmaps
End Function
End Class
