Option Strict On
Imports System
'----------------------------------------------------------------------------
'    ,    
'TextBox.
'     TextBox,   
'  ,   ,
'     :
'###-##-####. 
'       ,
'  .
'----------------------------------------------------------------------------
Public Class SocialSecurityTextBox
Inherits System.Windows.Forms.TextBox

Private m_inputIsFullValidEntry As Boolean

'-------------------------------------------------------------
',  
'    
'-------------------------------------------------------------
Public ReadOnly Property IsFullValidInput() As Boolean
Get
  Return m_inputIsFullValidEntry
End Get
End Property

' StringBuilder,     
Private m_sb As System.Text.StringBuilder
'   
Const SSNumberLength As Integer = 11

'-------------------------------------------------------------
'
'-------------------------------------------------------------
Public Sub New()
  '     StringBuilder  
  '       
  m_sb = New System.Text.StringBuilder(SSNumberLength + 5)
  m_inputIsFullValidEntry = False
End Sub

'---------------------------------------------------------------------
'       
' :
'
'     :  ###-##-####
' :  01234567890
'
' [in] inString          : ,    
' [in/out] selectionStart:     ; 
'                                
'                             
'---------------------------------------------------------------------
Private Function formatText_NNN_NN_NNNN(ByVal inString As _
            String, ByRef selectionStart As Integer) As String
  Const firstDashIndex As Integer = 3
  Const secondDashIndex As Integer = 6

  '      
  '  StringBuilder,      .
  m_sb.Length = 0
  m_sb.Append(inString)

  '------------------------------------------------------------
  '    ,   
  '     
  '------------------------------------------------------------
  Dim currentCharIndex As Integer
  currentCharIndex = 0
  While ((currentCharIndex < m_sb.Length) AndAlso _
        (currentCharIndex < SSNumberLength))

    Dim currentChar As Char
    currentChar = m_sb(currentCharIndex)

    If ((currentCharIndex = firstDashIndex) OrElse _
        (currentCharIndex = secondDashIndex)) Then
      '-------------------------------------------------------
      'The character needs to be a "-"
      '-------------------------------------------------------
      If (currentChar <> "-"c) Then ' 

          m_sb.Insert(currentCharIndex, "-")

          '      ,
          '    
          If (currentCharIndex <= selectionStart) Then
            selectionStart = selectionStart + 1
          End If
      End If

      '  ,    
      currentCharIndex = currentCharIndex + 1
    Else
    '-------------------------------------------------------
    '   
    '-------------------------------------------------------
      If (System.Char.IsDigit(currentChar) = False) Then
        ' 
        m_sb.Remove(currentCharIndex, 1)
        '      ,
        '    
        If (currentCharIndex < selectionStart) Then
           selectionStart = selectionStart - 1
        End If

        '    ,   
        ' ,    ,
        '  
      Else
          '  ,  .
          currentCharIndex = currentCharIndex + 1
      End If
    End If
  End While

  '   ,  
  If (m_sb.Length > SSNumberLength) Then
      m_sb.Length = SSNumberLength
  End If

  '  
  Return m_sb.ToString()
End Function

Private m_in_OnChangeFunction As Boolean
Protected Overrides Sub OnTextChanged(ByVal e As EventArgs)
 '------------------------------------------------------------------
 '    .Text,    
 '  .         
 '         
 '- .
 '------------------------------------------------------------------
  If (m_in_OnChangeFunction = True) Then
        Return
  End If

  ',       OnChanged,
  '      (.  )
  m_in_OnChangeFunction = True

  '   .Text
  Dim oldText As String = Me.Text
  '   SelectionStart
  Dim selectionStart As Integer = Me.SelectionStart
  ' ,     
  Dim newText As String = formatText_NNN_NN_NNNN(oldText, _
                                 selectionStart)

  '    ,  
  ' .Text
  If (oldText <> newText) Then
    '    
    Me.Text = newText
    '   
    Me.SelectionStart = selectionStart
  End If

  '      
  ', ,       
  '  ,      
  ' ###-##-####.
  If (Me.Text.Length = SSNumberLength) Then
      ',       
    m_inputIsFullValidEntry = True
  Else
      ',         
    m_inputIsFullValidEntry = False
  End If

  '       ,    
  ',   
  MyBase.OnTextChanged(e)

  ',          
  '    .
  m_in_OnChangeFunction = False
End Sub


Protected Overrides Sub OnKeyPress( _
            ByVal e As System.Windows.Forms.KeyPressEventArgs)
  '  ,        , 
  '   ,   .
  Dim keyPressed As Char = e.KeyChar
  If (System.Char.IsLetter(keyPressed)) Then
      '   ,   
    e.Handled = True
    Return
  End If
  '    
  MyBase.OnKeyPress(e)
End Sub
End Class
