System.Data.DataSet m_myDataSet; // Dataset  

//   ,  
private bool m_indexesLookedUp = false;
private const int INVALID_INDEX = -1;
private int  m_IndexOfTestColumn_CreditCard = INVALID_INDEX;
private int  m_IndexOfTestColumn_TravelDate = INVALID_INDEX;
private int  m_IndexOfTestTable = INVALID_INDEX;

//   ,  
System.Data.DataColumn m_TestColumn_CreditCard;
System.Data.DataColumn m_TestColumn_TravelDate;
private System.Data.DataTable m_TableCustomerInfo;

//3  ,    
public enum testType
{ textColumnLookup,  cachedIndexLookup,  cachedColumnObject }

//     
const int DUMMY_ROWS_OF_DATA = 100;
const int NUMBER_TEST_ITERATIONS = 500;

// 
const string TABLE_NAME_PASSENGERINFO = "CustomerTravelInfo";
const string COLUMN_NAME_DATE_OF_TRAVEL = "DateOfTravel";
const string COLUMN_NAME_PASSENGER_NAME = "PassengerName";
const string COLUMN_NAME_PASSENGER_CREDIT_CARD = "PassengerCreditCard";
const string TEST_CREDIT_CARD = "IvoCard-987-654-321-000";

//----------------------------------------------------------
//  
//----------------------------------------------------------
private void createDataSet()
{
  //1.    DataSet 
m_myDataSet = new System.Data.DataSet("TravelService Dataset");

  //2.   DataTable   ADO.NET DataSet
  System.Data.DataTable myTestTable;
 myTestTable = m_myDataSet.Tables.Add(TABLE_NAME_PASSENGERINFO);

  // 2   
  //     DataTable   DataSet
  myTestTable.Columns.Add(COLUMN_NAME_DATE_OF_TRAVEL, 
    typeof(System.DateTime));
  //     DataTable   DataSet
  myTestTable.Columns.Add(COLUMN_NAME_PASSENGER_NAME, 
    typeof(string));

  //     DataTable   DataSet
  myTestTable.Columns.Add(COLUMN_NAME_PASSENGER_CREDIT_CARD, typeof(string));

  //     
  object[] objArray;
  objArray = new object[3]; 

  //------------------------------------
  //    
  //------------------------------------
  System.Text.StringBuilder buildTestString;
  buildTestString = new System.Text.StringBuilder();
  for(int addItemsCount = 0; addItemsCount < DUMMY_ROWS_OF_DATA;
  addItemsCount++)
  {
    //   
    objArray[0] = System.DateTime.Today.AddDays(addItemsCount);

    //  
    buildTestString.Length = 0;
    buildTestString.Append("TestPersonName");
    buildTestString.Append(addItemsCount);
    objArray[1] = buildTestString.ToString();

    //      
    buildTestString.Length = 0;
    buildTestString.Append("IvoCard-000-000-0000-");
    buildTestString.Append(addItemsCount);
    objArray[2] = buildTestString.ToString();

    //      
    myTestTable.Rows.Add(objArray);
  }

  // ,        
  objArray[0] = System.DateTime.Today;
  objArray[1] = "Ms. TestPerson";
  objArray[2] = TEST_CREDIT_CARD;

  //      
  myTestTable.Rows.Add(objArray);
} // 


//---------------------------------------------------------------
//      ,   
//---------------------------------------------------------------
private void cacheDataSetInfo()
{
  //  ,    
  if (m_indexesLookedUp == true) {return;}

  //  
  m_IndexOfTestTable = 
    m_myDataSet.Tables.IndexOf(TABLE_NAME_PASSENGERINFO);

  //--------------------------------------------------------
  //     
  //    
  //--------------------------------------------------------
  m_TableCustomerInfo = m_myDataSet.Tables[m_IndexOfTestTable];

  int dataColumnCount = m_TableCustomerInfo.Columns.Count;
  System.Data.DataColumn myColumn;
  for(int colIdx = 0; colIdx < dataColumnCount;)
  {
    myColumn = m_TableCustomerInfo.Columns[colIdx];

    // ,      
    if (m_IndexOfTestColumn_CreditCard == INVALID_INDEX)
    { 
      //,   
      if (myColumn.ColumnName == 
           COLUMN_NAME_PASSENGER_CREDIT_CARD)
      { 
        //             
        m_IndexOfTestColumn_CreditCard = colIdx;
        
        // 
        m_TestColumn_CreditCard = myColumn;            
        goto next_loop_iteration; //   ...
      } //Endif:  
    } //Endif 

    if (m_IndexOfTestColumn_TravelDate == INVALID_INDEX) 
    {
      //,   
      if (myColumn.ColumnName == 
            COLUMN_NAME_DATE_OF_TRAVEL)
      { 
        //             
        m_IndexOfTestColumn_TravelDate = colIdx;
        // 
        m_TestColumn_TravelDate = myColumn;
        goto next_loop_iteration; //   .
      } //Endif:  
    } //Endif

next_loop_iteration:
    colIdx++;
  } 
  m_indexesLookedUp = true;
}

//------------------------------------------------
// 
//------------------------------------------------
void changeDayOfTravel_test(testType kindOfTest)
{
  //  
  System.Windows.Forms.Cursor.Current = 
    System.Windows.Forms.Cursors.WaitCursor;

  //   ...
  System.DateTime newDate;
  newDate = System.DateTime.Today;
  changeDayOfTravel_textColumnLookup(TEST_CREDIT_CARD, newDate);

  //    !!!
  //        !
  System.GC.Collect();
  const int testNumber = 0;

  //        
  switch(kindOfTest)
  {
    case testType.textColumnLookup: 
      PerformanceSampling.StartSample(testNumber,
            "Text based Column lookup.");
      break;

    case testType.cachedIndexLookup:
      PerformanceSampling.StartSample(testNumber, 
                    "Cached Column Index lookup.");
      break;

    case testType.cachedColumnObject:
      PerformanceSampling.StartSample(testNumber, 
                     "Cached Column objects");
      break;

    default:
      throw new Exception("Unknown state!");
  }
  
  // !
  for(int testCount = 0; 
      testCount < NUMBER_TEST_ITERATIONS; testCount++)
  {
    //     
    newDate = newDate.AddDays(1);
    int numberRecordsChanged = 0;

    //    ?
    switch(kindOfTest)
    {
      case testType.textColumnLookup: 
        // :   ,  
        numberRecordsChanged = 
            changeDayOfTravel_textColumnLookup(
                      TEST_CREDIT_CARD, newDate);
        break;

      case testType.cachedIndexLookup:
        // :    
        numberRecordsChanged = 
          changeDayOfTravel_cachedColumnIndex(
                      TEST_CREDIT_CARD, newDate);
        break;

      case testType.cachedColumnObject:
        // :   
        // 
        numberRecordsChanged = 
          changeDayOfTravel_CachedColumns(
                      TEST_CREDIT_CARD, newDate);
        break;
    }

    //  ,   ,   ...
    if(numberRecordsChanged != 1)
    {
      System.Windows.Forms.MessageBox.Show(  
        "No matching records found. Test aborted!");
      return;
    }
  }
  // ,     
  PerformanceSampling.StopSample(testNumber);

  // 
  System.Windows.Forms.Cursor.Current = 
    System.Windows.Forms.Cursors.Default;
                   
  //   
  string runInfo = NUMBER_TEST_ITERATIONS.ToString() + "x" + 
    DUMMY_ROWS_OF_DATA.ToString() + ": ";
  System.Windows.Forms.MessageBox.Show(runInfo +
    PerformanceSampling.GetSampleDurationText(testNumber));
}

// ,   
private int changeDayOfTravel_textColumnLookup(
        string creditCardNumber, System.DateTime newTravelDate)
{
  int numberRecordsChanged = 0;
  //  
  System.Data.DataTable dataTable_Customers;
  // :    , 
  // !
  dataTable_Customers = 
    m_myDataSet.Tables[TABLE_NAME_PASSENGERINFO];

  foreach(System.Data.DataRow currentCustomerRow in 
                            dataTable_Customers.Rows)
  {
    string currentCreditCard;
    // :    , 
    // !
    currentCreditCard = (string) 
      currentCustomerRow[COLUMN_NAME_PASSENGER_CREDIT_CARD];
    //,      
    if(creditCardNumber == currentCreditCard)
    {
      //  
      // :   ,  
      // !
      System.DateTime currentTravelDate = (System.DateTime) 
            currentCustomerRow[COLUMN_NAME_DATE_OF_TRAVEL];

      if(currentTravelDate != newTravelDate)
      {
        // :   ,  
        // !
        currentCustomerRow[COLUMN_NAME_DATE_OF_TRAVEL] = 
            newTravelDate;
        numberRecordsChanged++;
      } 
    } //endif:  
  } //end foreach

    return numberRecordsChanged; //  
  }

//,    
private int changeDayOfTravel_cachedColumnIndex(
      string creditCardNumber, System.DateTime newTravelDate)
  {
    int numberRecordsChanged = 0;
    //  
    System.Data.DataTable dataTable_Customers;
    // :   
    dataTable_Customers = 
      m_myDataSet.Tables[m_IndexOfTestTable];

    foreach(System.Data.DataRow currentCustomerRow in 
            dataTable_Customers.Rows)
    {
      string currentCreditCard;
      // :    !
      currentCreditCard = (string) 
        currentCustomerRow[m_IndexOfTestColumn_CreditCard];
      //,     ...
      if(creditCardNumber == currentCreditCard)
      {
        //  
        // :    !
        System.DateTime currentTravelDate = (System.DateTime)
            currentCustomerRow[m_IndexOfTestColumn_TravelDate];

        if(currentTravelDate != newTravelDate)
        {
          // :   
          //!
          currentCustomerRow[m_IndexOfTestColumn_TravelDate] =
                            newTravelDate;
          numberRecordsChanged++;
        }
      }
    }
  return numberRecordsChanged;  //  
}

//,   
private int changeDayOfTravel_CachedColumns(
      string creditCardNumber, System.DateTime newTravelDate)
{
  int numberRecordsChanged = 0;
  //  
  System.Data.DataTable dataTable_Customers = 
                          m_TableCustomerInfo;

  foreach(System.Data.DataRow currentCustomerRow in 
          dataTable_Customers.Rows)
  {
    string currentCreditCard;
    // :    !
    currentCreditCard = (string) 
        currentCustomerRow[m_TestColumn_CreditCard];
    //,     ...
    if(creditCardNumber == currentCreditCard)
    {
      //  
      // :    !
      System.DateTime currentTravelDate = (System.DateTime) 
          currentCustomerRow[m_TestColumn_TravelDate];
      if(currentTravelDate != newTravelDate)
      {
        // :   
        //!
        currentCustomerRow[m_TestColumn_TravelDate] = 
              newTravelDate;
        numberRecordsChanged++;
      }
    }
  }
  return numberRecordsChanged;  //  
}

//   
private void buttonRunTest_Click(object sender, 
                                  System.EventArgs e)
{
  createDataSet();  cacheDataSetInfo();

  // :    
  changeDayOfTravel_test(testType.textColumnLookup);

  // :     
  changeDayOfTravel_test(testType.cachedIndexLookup);

  // :     
  changeDayOfTravel_test(testType.cachedColumnObject);
}
