Private m_myDataSet As System.Data.DataSet '   
'   ,  
Private m_indexesLookedUp As Boolean = False
Private Const INVALID_INDEX As Integer = -1
Private m_IndexOfTestColumn_CreditCard _
        As Integer = INVALID_INDEX
Private m_IndexOfTestColumn_TravelDate _
        As Integer = INVALID_INDEX
Private m_IndexOfTestTable As Integer = INVALID_INDEX

'   ,  
Private m_TestColumn_CreditCard As System.Data.DataColumn
Private m_TestColumn_TravelDate As System.Data.DataColumn
Private m_TableCustomerInfo As System.Data.DataTable

Public Enum testType '3  ,    
 textColumnLookup
 cachedIndexLookup
 cachedColumnObject
End Enum

'     
Const DUMMY_ROWS_OF_DATA As Integer = 100
Const NUMBER_TEST_ITERATIONS As Integer = 500

' 
Const TABLE_NAME_PASSENGERINFO As String = "CustomerTravelInfo"
Const COLUMN_NAME_DATE_OF_TRAVEL As String = "DateOfTravel"
Const COLUMN_NAME_PASSENGER_NAME As String = "PassengerName"
Const COLUMN_NAME_PASSENGER_CREDIT_CARD As String = _
                                       "PassengerCreditCard"
Const TEST_CREDIT_CARD As String = "IvoCard-987-654-321-000"

'----------------------------------------------------------
'  
'----------------------------------------------------------
Private Sub createDataSet()
  '1.    DataSet 
 m_myDataSet = New System.Data.DataSet("TravelService Dataset")

  '2.   DataTable   ADO.NET DataSet
  Dim myTestTable As System.Data.DataTable
 myTestTable = m_myDataSet.Tables.Add(TABLE_NAME_PASSENGERINFO)

  ' 2   
  '     DataTable   DataSet
  myTestTable.Columns.Add(COLUMN_NAME_DATE_OF_TRAVEL, _
    GetType(System.DateTime))
  '     DataTable   DataSet
  myTestTable.Columns.Add(COLUMN_NAME_PASSENGER_NAME, _
    GetType(String))

  '     DataTable   DataSet
  myTestTable.Columns.Add(COLUMN_NAME_PASSENGER_CREDIT_CARD, _
                                               GetType(String))
  '     
  Dim objArray() As Object
  ReDim objArray(2)

  '------------------------------------
  '    
  '------------------------------------
  Dim buildTestString As System.Text.StringBuilder
  buildTestString = New System.Text.StringBuilder
  Dim addItemsCount As Integer
  For addItemsCount = 1 To DUMMY_ROWS_OF_DATA
      '   
    objArray(0) = System.DateTime.Today.AddDays(addItemsCount)

    '  
    buildTestString.Length = 0
    buildTestString.Append("TestPersonName")
    buildTestString.Append(addItemsCount)
    objArray(1) = buildTestString.ToString()

    '      
    buildTestString.Length = 0
    buildTestString.Append("IvoCard-000-000-0000-")
    buildTestString.Append(addItemsCount)
    objArray(2) = buildTestString.ToString()

    '      
    myTestTable.Rows.Add(objArray)
  Next

  ' ,        
  objArray(0) = System.DateTime.Today
  objArray(1) = "Ms. TestPerson"
  objArray(2) = TEST_CREDIT_CARD

  '      
  myTestTable.Rows.Add(objArray)
End Sub

'---------------------------------------------------------------
'      ,   
'---------------------------------------------------------------
Private Sub cacheDataSetInfo()
  '  ,    
  If (m_indexesLookedUp = True) Then Return

  '  
  m_IndexOfTestTable = _
    m_myDataSet.Tables.IndexOf(TABLE_NAME_PASSENGERINFO)

  '--------------------------------------------------------
  '     
  '    
  '--------------------------------------------------------
  m_TableCustomerInfo = m_myDataSet.Tables(m_IndexOfTestTable)

  Dim dataColumnCount As Integer
  dataColumnCount = m_TableCustomerInfo.Columns.Count
  Dim myColumn As System.Data.DataColumn
  Dim colIdx As Integer
  While (colIdx < dataColumnCount)
      myColumn = m_TableCustomerInfo.Columns(colIdx)

    ' ,      
    If (m_IndexOfTestColumn_CreditCard = INVALID_INDEX) Then

      ',   
      If (myColumn.ColumnName = _ 
COLUMN_NAME_PASSENGER_CREDIT_CARD) Then

        '           
        m_IndexOfTestColumn_CreditCard = colIdx

        ' 
        m_TestColumn_CreditCard = myColumn
        GoTo next_loop_iteration '   ...
      End If 'Endif:  
    End If

    If (m_IndexOfTestColumn_TravelDate = INVALID_INDEX) Then
          ',   
      If (myColumn.ColumnName = _
            COLUMN_NAME_DATE_OF_TRAVEL) Then

        '         
        m_IndexOfTestColumn_TravelDate = colIdx
        ' 
        m_TestColumn_TravelDate = myColumn
        GoTo next_loop_iteration '   
      End If 'Endif:  
    End If

next_loop_iteration:
    colIdx = colIdx + 1
  End While
  m_indexesLookedUp = True
End Sub

'------------------------------------------------
' .
'------------------------------------------------
Sub changeDayOfTravel_test(ByVal kindOfTest As testType)
  '  
  System.Windows.Forms.Cursor.Current = _
    System.Windows.Forms.Cursors.WaitCursor

  '   
  Dim newDate As System.DateTime
  newDate = System.DateTime.Today
  changeDayOfTravel_textColumnLookup(TEST_CREDIT_CARD, newDate)

  '    !!!
  '        !
  System.GC.Collect()
  Const testNumber As Integer = 0

  '        
 Select Case (kindOfTest)
      Case testType.textColumnLookup
      PerformanceSampling.StartSample(testNumber, _
            "Text based Column lookup.")

    Case testType.cachedIndexLookup
      PerformanceSampling.StartSample(testNumber, _
                    "Cached Column Index lookup.")

    Case testType.cachedColumnObject
      PerformanceSampling.StartSample(testNumber, _
                     "Cached Column objects")

    Case Else
      Throw New Exception("Unknown state!")
  End Select

  ' !
  Dim testCount As Integer
  For testCount = 1 To NUMBER_TEST_ITERATIONS
      '     
    newDate = newDate.AddDays(1)
    Dim numberRecordsChanged As Integer = 0

    '    ?
   Select Case (kindOfTest)
      Case testType.textColumnLookup
        ' :   ,  
        numberRecordsChanged = _
            changeDayOfTravel_textColumnLookup( _
                      TEST_CREDIT_CARD, newDate)

      Case testType.cachedIndexLookup
        ' :     
        numberRecordsChanged = _
          changeDayOfTravel_cachedColumnIndex( _
                      TEST_CREDIT_CARD, newDate)

      Case testType.cachedColumnObject
        ' :   
        numberRecordsChanged = _
          changeDayOfTravel_CachedColumns( _
                      TEST_CREDIT_CARD, newDate)
      End Select

    '  ,   ,   
    If (numberRecordsChanged <> 1) Then
          MsgBox("No matching records found. Test aborted!")
      Return
    End If
  Next
  ' ,     
  PerformanceSampling.StopSample(testNumber)

  ' 
  System.Windows.Forms.Cursor.Current = _
    System.Windows.Forms.Cursors.Default

  '   
  Dim runInfo As String = NUMBER_TEST_ITERATIONS.ToString() + _
    "x" + DUMMY_ROWS_OF_DATA.ToString() + ": "

  MsgBox(runInfo + _
    PerformanceSampling.GetSampleDurationText(testNumber))
End Sub

' ,   
Private Function changeDayOfTravel_textColumnLookup( _
        ByVal creditCardNumber As String, _
        ByVal newTravelDate As System.DateTime) As Integer
  Dim numberRecordsChanged As Integer
  '  
  Dim dataTable_Customers As System.Data.DataTable
  ' :    , 
  ' !
  dataTable_Customers = _
    m_myDataSet.Tables(TABLE_NAME_PASSENGERINFO)

  Dim currentCustomerRow As System.Data.DataRow
  For Each currentCustomerRow In dataTable_Customers.Rows
    Dim currentCreditCard As String

    ' :    , 
    ' !
    currentCreditCard = CType( _
    currentCustomerRow(COLUMN_NAME_PASSENGER_CREDIT_CARD), _
    String)

    ',      
    If (creditCardNumber = currentCreditCard) Then
      '  
      ' :   ,  
      ' !
      Dim currentTravelDate As System.DateTime = CType( _
            currentCustomerRow(COLUMN_NAME_DATE_OF_TRAVEL), _
            System.DateTime)

      If (currentTravelDate <> newTravelDate) Then
        ' :   ,  
        ' !
        currentCustomerRow(COLUMN_NAME_DATE_OF_TRAVEL) = _
            newTravelDate
        numberRecordsChanged = numberRecordsChanged + 1
      End If
    End If 'endif:  
  Next 'end for each

    Return numberRecordsChanged '  
End Function

',    
Private Function changeDayOfTravel_cachedColumnIndex( _
      ByVal creditCardNumber As String, ByVal newTravelDate _
      As DateTime) As Integer

    Dim numberRecordsChanged As Integer
    '  
    Dim dataTable_Customers As System.Data.DataTable
    ' :   
    dataTable_Customers = _
      m_myDataSet.Tables(m_IndexOfTestTable)

    Dim currentCustomerRow As System.Data.DataRow
    For Each currentCustomerRow In dataTable_Customers.Rows
      Dim currentCreditCard As String
      ' :    !
      currentCreditCard = CType(currentCustomerRow( _
        m_IndexOfTestColumn_CreditCard), String)
      ',     
      If (creditCardNumber = currentCreditCard) Then
        '  
        ' :    !
        Dim currentTravelDate As System.DateTime = CType( _
        currentCustomerRow(m_IndexOfTestColumn_TravelDate), _
        System.DateTime)

        If (currentTravelDate <> newTravelDate) Then
          ' :    !
          currentCustomerRow(m_IndexOfTestColumn_TravelDate) = _
                            newTravelDate
          numberRecordsChanged = numberRecordsChanged + 1
        End If
      End If
    Next
  Return numberRecordsChanged  '  
End Function

',   
Private Function changeDayOfTravel_CachedColumns( _
      ByVal creditCardNumber As String, _
      ByVal newTravelDate As System.DateTime) As Integer
  Dim numberRecordsChanged As Integer

  '  
  Dim dataTable_Customers As System.Data.DataTable = _
                          m_TableCustomerInfo

  Dim currentCustomerRow As System.Data.DataRow
  For Each currentCustomerRow In dataTable_Customers.Rows
    Dim currentCreditCard As String
    ' :    !
    currentCreditCard = CType( _
        currentCustomerRow(m_TestColumn_CreditCard), _
        String)

    ',     
    If (creditCardNumber = currentCreditCard) Then
          '  
      ' :    !
      Dim currentTravelDate As System.DateTime = CType( _
          currentCustomerRow(m_TestColumn_TravelDate), _
          System.DateTime)

      If (currentTravelDate <> newTravelDate) Then
       ' :    !
        currentCustomerRow(m_TestColumn_TravelDate) = _
              newTravelDate
        numberRecordsChanged = numberRecordsChanged + 1
      End If
    End If
  Next
  Return numberRecordsChanged  '  
End Function

'   
Private Sub buttonRunTest_Click(ByVal sender As Object, _
  ByVal e As System.EventArgs) Handles buttonRunTest.Click

  createDataSet()
  cacheDataSetInfo()

  ' :    
  changeDayOfTravel_test(testType.textColumnLookup)

  ' :     
  changeDayOfTravel_test(testType.cachedIndexLookup)

  ' :     
  changeDayOfTravel_test(testType.cachedColumnObject)
End Sub
