'   
Const DUMMY_ROWS_OF_DATA As Integer = 100
Const NUMBER_TEST_ITERATIONS As Integer = 500

Const TABLE_NAME_PASSENGERINFO As String = "CustomerTravelInfo"
Const TEST_CREDIT_CARD As String = "IvoCard-987-654-321-000"

Private m_data_creditCards() As String
Private m_data_names() As String
Private m_data_travelDates() As System.DateTime

'-------------------------------------------------------------
'   (   DaraSet)
'-------------------------------------------------------------
Private Sub createDataSet()
  '=============================================
  '1.     
  '=============================================
  ReDim m_data_creditCards(DUMMY_ROWS_OF_DATA)
  ReDim m_data_names(DUMMY_ROWS_OF_DATA)
  ReDim m_data_travelDates(DUMMY_ROWS_OF_DATA)

  '------------------------------------
  '  
  '------------------------------------
  Dim buildTestString As System.Text.StringBuilder
  buildTestString = New System.Text.StringBuilder
  Dim addItemsCount As Integer
  For addItemsCount = 0 To DUMMY_ROWS_OF_DATA
    '   
    m_data_travelDates(addItemsCount) = _
      System.DateTime.Today.AddDays(addItemsCount)

    '------------------------------------
    '  
    '------------------------------------
    ' 
    buildTestString.Length = 0
    buildTestString.Append("TestPersonName")
    buildTestString.Append(addItemsCount)
    m_data_names(addItemsCount) = buildTestString.ToString()

    '-------------------------------------------------------
    '      
    '-------------------------------------------------------
    '     
    buildTestString.Length = 0
    buildTestString.Append("IvoCard-000-000-0000-")
    buildTestString.Append(addItemsCount)
    m_data_creditCards(addItemsCount) = _
                        buildTestString.ToString()
  Next

  ' ,        .
  '       
  m_data_travelDates(DUMMY_ROWS_OF_DATA) = _
                            System.DateTime.Today
  '    
  m_data_names(DUMMY_ROWS_OF_DATA) = "Ms. TestPerson"
  '    
  m_data_creditCards(DUMMY_ROWS_OF_DATA) = TEST_CREDIT_CARD
End Sub

'------------------------------------------------
' .
'------------------------------------------------
Sub changeDayOfTravel_test()
  '  
  System.Windows.Forms.Cursor.Current = _
    System.Windows.Forms.Cursors.WaitCursor

  '   .
  Dim newDate As System.DateTime
  newDate = System.DateTime.Today
  changeDayOfTravel_CustomArrays(TEST_CREDIT_CARD, newDate)

  '   !!!
  '        
  '.    .
  System.GC.Collect()
  Const testNumber As Integer = 0

  '  
  PerformanceSampling.StartSample(testNumber, _
                "Custom Array implementation")

  ' !
  Dim testCount As Integer
  For testCount = 1 To NUMBER_TEST_ITERATIONS

    '     
    newDate = newDate.AddDays(1)
    Dim numberRecordsChanged As Integer

    '  ,  
    numberRecordsChanged = _
          changeDayOfTravel_CustomArrays( _
          TEST_CREDIT_CARD, newDate)

    '    
    If (numberRecordsChanged <> 1) Then
          MsgBox("No matching records found. Test aborted!")
      Return
    End If
  Next
  '   
  PerformanceSampling.StopSample(testNumber)

  ' 
  System.Windows.Forms.Cursor.Current = _
    System.Windows.Forms.Cursors.Default

  '  
  Dim runInfo As String = NUMBER_TEST_ITERATIONS.ToString() + _
    "x" + DUMMY_ROWS_OF_DATA.ToString() + ": "
  MsgBox(runInfo + _
    PerformanceSampling.GetSampleDurationText(testNumber))
End Sub

Private Function changeDayOfTravel_CustomArrays( _
  ByVal creditCardNumber As String, ByVal newTravelDate _
  As System.DateTime) As Integer

  Dim numberRecordsChanged As Integer

  '   
  Dim index As Integer
  For index = 0 To DUMMY_ROWS_OF_DATA
    Dim currentCreditCard As String
    currentCreditCard = m_data_creditCards(index)

    '    
    If (creditCardNumber = currentCreditCard) Then
      '  
      Dim currentTravelDate As System.DateTime = _
        m_data_travelDates(index)

      '       
      If (currentTravelDate <> newTravelDate) Then
              m_data_travelDates(index) = _
          newTravelDate
        numberRecordsChanged = numberRecordsChanged + 1
      End If
    End If
  Next
  '   
  Return numberRecordsChanged
End Function

Private Sub buttonRunTest_Click(ByVal sender As Object, _
      ByVal e As System.EventArgs) Handles buttonRunTest.Click
  createDataSet()
  changeDayOfTravel_test()
End Sub
