Option Strict On
'-----------------------------------------------------------------
'    
'
'        
'-----------------------------------------------------------------
Imports System

Friend Class GameData
'     
Private Shared m_vocabularyWords_All As _
  System.Collections.ArrayList
Private Shared m_vocabularyWords_Nouns As _
  System.Collections.ArrayList
Private Shared m_vocabularyWords_Verbs As _
  System.Collections.ArrayList
Private Shared m_vocabularyWords_Adjectives As _
  System.Collections.ArrayList
Private Shared m_vocabularyWords_Adverbs As _
  System.Collections.ArrayList
Private Shared m_vocabularyWords_Prepositions As _
  System.Collections.ArrayList


Public Shared ReadOnly Property _
            isGameDataInitialized() As Boolean
  Get
  '  ,   
    Return Not (m_vocabularyWords_All Is Nothing)
  End Get
End Property

'    
Public Shared ReadOnly Property _
          AllWords() As System.Collections.ArrayList
  Get
      ' ,     
    If (m_vocabularyWords_All Is Nothing) Then
        InitializeGameVocabulary()
    End If
    Return m_vocabularyWords_All
  End Get
End property

'     
Public Shared ReadOnly Property _
          Nouns() As System.Collections.ArrayList
  Get
      ' ,     
    If (m_vocabularyWords_Nouns Is Nothing) Then
        InitializeGameVocabulary()
    End If
    Return m_vocabularyWords_Nouns
  End Get
End Property

'==========================================================
'     
'==========================================================
Public Shared Sub InitializeGameVocabulary()
  '       
  m_vocabularyWords_All = New System.Collections.ArrayList
  m_vocabularyWords_Nouns = New System.Collections.ArrayList
  m_vocabularyWords_Verbs = New System.Collections.ArrayList
  m_vocabularyWords_Adjectives = _
                            New System.Collections.ArrayList
  m_vocabularyWords_Adverbs = _
                            New System.Collections.ArrayList
  m_vocabularyWords_Prepositions = _
                            New System.Collections.ArrayList

  Dim dataReader As System.Data.IDataReader
  dataReader = DatabaseAccess.GetListOfWords()

  Dim newWord As VocabularyWord
  '  
  While (dataReader.Read())
    Dim thisword_gender As VocabularyWord.WordGender
    Dim thisword_function As VocabularyWord.WordFunction
    thisword_gender = CType(dataReader.GetInt32( _
           DatabaseAccess.DS_WORDS_COLUMNINDEX_GERMANGENDER), _
           VocabularyWord.WordGender)

    thisword_function = CType(dataReader.GetInt32( _
            DatabaseAccess.DS_WORDS_COLUMNINDEX_WORDFUNCTION), _
            VocabularyWord.WordFunction)

      '        
    newWord = New VocabularyWord( _
        dataReader.GetString( _
          DatabaseAccess.DS_WORDS_COLUMNINDEX_ENGLISHWORD), _
        dataReader.GetString( _
          DatabaseAccess.DS_WORDS_COLUMNINDEX_GERMANWORD), _
        thisword_gender, thisword_function)

    '     
    m_vocabularyWords_All.Add(newWord)

    '    , 
    '       
    '  ,      
    If ((newWord.getWordFunction And _
        VocabularyWord.WordFunction.Noun) <> 0) Then
      m_vocabularyWords_Nouns.Add(newWord)
    End If

    If ((newWord.getWordFunction And _
        VocabularyWord.WordFunction.Verb) <> 0) Then
      m_vocabularyWords_Verbs.Add(newWord)
    End If

    If ((newWord.getWordFunction And _
        VocabularyWord.WordFunction.Adjective) <> 0) Then
      m_vocabularyWords_Adjectives.Add(newWord)
    End If

    If ((newWord.getWordFunction And _
        VocabularyWord.WordFunction.Adverb) <> 0) Then
      m_vocabularyWords_Adverbs.Add(newWord)
    End If

    If ((newWord.getWordFunction And _
        VocabularyWord.WordFunction.Preposition) <> 0) Then
      m_vocabularyWords_Prepositions.Add(newWord)
    End If

  End While
  '  DataReader
  dataReader.Close()
End Sub
End Class
