using System;
//-----------------------------------------------
//    
//-----------------------------------------------
internal class VocabularyWord
{

[System.FlagsAttribute] //     
                          //  	 
public enum WordFunction
{
  Noun = 1,
  Verb = 2,
  Pronoun = 4,
  Adverb = 8,
  Adjective = 16,
  Preposition = 32,
  Phrase = 64
}

public enum WordGender
{
  notApplicable = 0,
  Masculine = 1,
  Feminine = 2,
  Neuter = 3,
}

private string m_englishWord;
private string m_germanWord;
private VocabularyWord.WordGender m_germanGender;
private VocabularyWord.WordFunction m_wordFunction;

public string EnglishWord {get {return m_englishWord;}}
public string GermanWord {get {return m_germanWord;}}
public WordFunction getWordFunction 
        {get {return m_wordFunction;}}
public WordGender GermanGender {get {return m_germanGender;}}

//-----------------------------------------------------------------
//    ,    
//(, 'der', 'die', 'das'),   
//-----------------------------------------------------------------
public string GermanWordWithArticleIfExists
{
  get
  {
    if (m_germanGender == WordGender.notApplicable)
    {
      return this.GermanWord;
    }

    return this.GenderArticle + " " + this.GermanWord;

  }
} // 

public string GenderArticle
{
  get
  {
    switch (m_germanGender)
    {
      case WordGender.Masculine:
        return "der";
      case WordGender.Feminine:
        return "die";
      case WordGender.Neuter:
        return "das";
    }
    return "";
  }
}

public VocabularyWord(string enlgishWord, string germanWord, 
          WordGender germanGender, WordFunction wordFunction)
{
  m_englishWord = enlgishWord;
  m_germanWord = germanWord;
  m_germanGender = germanGender;
  m_wordFunction = wordFunction;
}
}  // 
