using System;
public class FindNextPrimeNumber
{
  //  
  public enum ProcessingState
  {
    notYetStarted,
    waitingToStartAsync,
    lookingForPrime,
    foundPrime,
    requestAbort,
    aborted
  }

  int m_startTickCount;
  int m_endTickCount;
  long m_startPoint;
  long m_NextHighestPrime;
  ProcessingState m_processingState;

  //--------------------------------------------------
  //   
  //--------------------------------------------------
  public void setProcessingState(ProcessingState nextState)
  {
    //------------------------------------------------------------
    //  ,  
    //      
    //      
    //------------------------------------------------------------		
    if   ((m_processingState == ProcessingState.aborted)
      ||  (m_processingState == ProcessingState.foundPrime))
    {
      return;
    }

    //  
    lock(this)
    {
    m_processingState = nextState;
    }  
 }

  public ProcessingState getProcessingState()
  {
    ProcessingState currentState;
    //  
    lock(this)
    {
      currentState = m_processingState;
    }
    return currentState;
  }

  public int getTickCountDelta()
  {
    if (getProcessingState() == ProcessingState.lookingForPrime)
    {
      throw new Exception(
    "   !     ");
    }

    return m_endTickCount - m_startTickCount;
  }

  //---------------------------------------------------
  //  
  //---------------------------------------------------
  public long getPrime()
  {
    if (getProcessingState() != ProcessingState.foundPrime)
    {
      throw new Exception("    !");
    }

    return m_NextHighestPrime;
  }

  // 
  public FindNextPrimeNumber(long startPoint)
  {
    setProcessingState(ProcessingState.notYetStarted);
    m_startPoint = startPoint;
  }

  //-----------------------------------------------------------
  //   ,    
  // "findNextHighestPrime()" 
  //-----------------------------------------------------------
  public void findNextHighestPrime_Async()
  {
    System.Threading.ThreadStart threadStart;
    threadStart = 
      new System.Threading.ThreadStart(findNextHighestPrime);

    System.Threading.Thread newThread;
    newThread = new System.Threading.Thread(threadStart);

    //  ,   
    setProcessingState(ProcessingState.waitingToStartAsync);
    newThread.Start();
  }

  //------------------------------------------------------------------
  //  .     
  //      ,   
  //    :
  // (a)    
  // (b)   (   )   
  //      
  //------------------------------------------------------------------
  public void findNextHighestPrime()
  {
    //    ,  
    //   
    if(getProcessingState() == ProcessingState.requestAbort)
    {
      goto finished_looking;
    }

    //  ,   
    setProcessingState(ProcessingState.lookingForPrime);

    m_startTickCount = System.Environment.TickCount;
    long currentItem;
    //,    
    if ((m_startPoint & 1) == 1)
    {
      //  ,      
      currentItem = m_startPoint + 2;
    }
    else
    {
      //  ,       
      currentItem = m_startPoint + 1;
    }

    //    
    while(getProcessingState()  == 
          ProcessingState.lookingForPrime)
    {

      //      
      if(isItemPrime(currentItem) == true)
      {
        m_NextHighestPrime =  currentItem;
        // 
        setProcessingState(ProcessingState.foundPrime);
      }

      currentItem = currentItem  + 2;
    }

finished_looking:
      //.        
      //  ,     
      //   

      // 
      m_endTickCount = System.Environment.TickCount;

    //    , 
    //,    
    if (getProcessingState() == ProcessingState.requestAbort)
    {
      setProcessingState(ProcessingState.aborted);
    }
  } // 

  // ,  , 
  //  
  private bool isItemPrime(long potentialPrime)
  {
    //  - , ,    
    if ((potentialPrime & 1) == 0)
    {
      return false;
    }

    //    ,    
    //    
    long end_point_of_search;
    end_point_of_search = 
      (long) System.Math.Sqrt(potentialPrime) + 1;

    long current_test_item = 3;
    while(current_test_item <= end_point_of_search )
    {
      //---------------------------------------------------------
      //,      !
      //---------------------------------------------------------
      if (getProcessingState() != 
            ProcessingState.lookingForPrime)
      {
        return false;
      }

      //    , 
      //,    
      if(potentialPrime % current_test_item == 0)
      {
        return false;
      }

      //   
      current_test_item  = current_test_item  + 2;
    }

    //  
    return true;
  }
} // 
