using System;

internal class PerformanceSampling
{
  //      ,   
  // ,  8,    
  //
  const int NUMBER_SAMPLERS = 8;

  static  string [] m_perfSamplesNames = 
                      new string[NUMBER_SAMPLERS];

  static  int [] m_perfSamplesStartTicks = 
                      new int[NUMBER_SAMPLERS];

  static  into [] m_perfSamplesDuration = 
                      new int[NUMBER_SAMPLERS];

  //        
  internal static void StartSample(int sampleIndex, 
                                   string sampleName)
  {
    m_perfSamplesNames[sampleIndex] = sampleName;

    m_perfSamplesStartTicks[sampleIndex] = 
      System.Environment.TickCount;
  }

  //         
  internal static void StopSample(int sampleIndex)
  {
    int stopTickCount = System.Environment.TickCount;

    //        24,9 
    //(   2  ).
    //       
    if (stopTickCount >= m_perfSamplesStartTicks[sampleIndex])
    {
      //    
      m_perfSamplesDuration[sampleIndex] = 
         stopTickCount - m_perfSamplesStartTicks[sampleIndex];
    }
    else
    {
      //   ""  ,
      //    
      m_perfSamplesDuration[sampleIndex] = 
        stopTickCount + 
        (int.MaxValue - m_perfSamplesStartTicks[sampleIndex])
        + 1;
    }

  }

  //    
  //( )
  internal static int GetSampleDuration(int sampleIndex)
  {
    return m_perfSamplesDuration[sampleIndex];
  }

  //    
  //  
  internal static string GetSampleDurationText(int sampleIndex)
  {
    return m_perfSamplesNames[sampleIndex] + ": " + 
      System.Convert.ToString(
        (m_perfSamplesDuration[sampleIndex] / (double) 1000.0)
       ) + " .";
  }
}
