Option Strict On
Imports System

Friend Class PerformanceSampling
'      ,   
' ,  8,    
'
Const NUMBER_SAMPLERS As Integer = 8

Private Shared m_perfSamplesNames(NUMBER_SAMPLERS) As String
Private Shared m_perfSamplesStartTicks(NUMBER_SAMPLERS) As _
                                                      Integer
Private Shared m_perfSamplesDuration(NUMBER_SAMPLERS) As Integer

'---------------------------------------------------------------------------
'        
'---------------------------------------------------------------------------
Friend Shared Sub StartSample(ByVal sampleIndex As Integer, _
                                  ByVal sampleName As String)

  m_perfSamplesNames(sampleIndex) = sampleName

  m_perfSamplesStartTicks(sampleIndex) = _
    System.Environment.TickCount()
End Sub

'--------------------------------------------------------------------------
'        
'--------------------------------------------------------------------------
Friend Shared Sub StopSample(ByVal sampleIndex As Integer)
  Dim stopTickCount As Integer = System.Environment.TickCount

  '        24,9 
  '(   2  )
  '       
  If (stopTickCount >= m_perfSamplesStartTicks(sampleIndex)) _
  Then
    '    
    m_perfSamplesDuration(sampleIndex) = _
        stopTickCount - m_perfSamplesStartTicks(sampleIndex)
  Else
    '   ""  ,  
    '  
    m_perfSamplesDuration(sampleIndex) = stopTickCount + _
(Integer.MaxValue - m_perfSamplesStartTicks(sampleIndex)) + 1
  End If
End Sub

'----------------------------------------------------
'    
'( )
'----------------------------------------------------
Friend Shared Function GetSampleDuration(ByVal sampleIndex _
                                      As Integer) As Integer
  Return m_perfSamplesDuration(sampleIndex)
End Function

'    
'   
Friend Shared Function GetSampleDurationText(ByVal _
                      sampleIndex As Integer) As String
  Return m_perfSamplesNames(sampleIndex) + ": " + _
    System.Convert.ToString( _
      (m_perfSamplesDuration(sampleIndex) / CDbl(1000.0)) _
      ) + " ."
End Function
End Class
