//===========================================================
//.      PerformanceSampling, 
//             .   ,  
//             
//===========================================================
// :
//
// 'n1'  'n2'   
// 'n3'
//
//  :
//   TRUE:   
//   FALSE:   
//===========================================================
bool returnFalseIfLessThanZero_Add2Numbers(int n1, int n2,
                                        out int n3)
{
  n3 = n1 + n2;
  
  //  0?
  if(n3 < 0)
  {
    return false;
  }
  return true;
}

//===========================================================
//  :
//
// 'n1'  'n2'   
// 'n3'
//
// 'n3'  0,      .
//    TRUE
//===========================================================
bool exceptionIfLessThanZero_Add2Numbers(int n1, int n2,
                  out int n3)
{
  n3 = n1 + n2;

  //  0?
  if(n3 < 0)
  {
    throw new Exception("  0!");
  }
  return true;
}


//===========================================================
//     
//   
//
//       
//===========================================================
private void buttonRunNoExceptionCode_Click(object sender, 
                                        System.EventArgs e)
{
const int TEST_NUMBER = 0;
int numberIterations;
numberIterations = 
  System.Convert.ToInt32(textBoxNumberAttempts.Text);

//  ,   
listBox1.Items.Add("=>" + numberIterations.ToString() + 
                        " ");

int count_SumLessThanZero;
int dataOut;

//-----------------------------------------------------------
// 
//-----------------------------------------------------------
PerformanceSampling.StartSample(TEST_NUMBER, " ");
//-----------------------------------------------------------
// ,     
//-----------------------------------------------------------
count_SumLessThanZero = 0;
bool sumGreaterThanZero;
for(int i = 0; i < numberIterations; i++)
{
  //=========================
  //  !
  //=========================
  sumGreaterThanZero = 
    returnFalseIfLessThanZero_Add2Numbers(-2, -3, out dataOut);

  if(sumGreaterThanZero == false)
  {
    count_SumLessThanZero++;
  }
} // 

//-----------------------------------------------------------
// 
//-----------------------------------------------------------
PerformanceSampling.StopSample(TEST_NUMBER);

//-----------------------------------------------------------
//  
//-----------------------------------------------------------
if(count_SumLessThanZero == numberIterations)
{
  System.Windows.Forms.MessageBox.Show(" ");
  listBox1.Items.Add(
   PerformanceSampling.GetSampleDurationText(TEST_NUMBER));
}
else
{
  System.Windows.Forms.MessageBox.Show(
      "    ");
}

} // 

//===========================================================
//     
//   .
//
//    
//===========================================================
private void buttonRunExceptionCode_Click(object sender, 
                        System.EventArgs e)
{
const int TEST_NUMBER = 1;

//  
int numberIterations;
numberIterations = 
  System.Convert.ToInt32(textBoxNumberAttempts.Text);

//  ,   
listBox1.Items.Add("=>" + numberIterations.ToString() + 
                          " ");

int count_SumLessThanZero;
int dataOut;

//-----------------------------------------------------------
// 
//-----------------------------------------------------------
PerformanceSampling.StartSample(TEST_NUMBER , 
                                " ");

//-----------------------------------------------------------
// ,     
//-----------------------------------------------------------
count_SumLessThanZero = 0;
bool sumGreaterThanZero;
for(int i = 0; i < numberIterations; i++)
{
  try
  {
  //=========================
  //  !
  //=========================
  sumGreaterThanZero = 
    exceptionIfLessThanZero_Add2Numbers(-2, -3, out dataOut);
  }
  catch
  {
    count_SumLessThanZero++;
  }

} // 

//-----------------------------------------------------------
// 
//-----------------------------------------------------------
PerformanceSampling.StopSample(TEST_NUMBER);

//-----------------------------------------------------------
//  
//-----------------------------------------------------------
if(count_SumLessThanZero == numberIterations)
{
  System.Windows.Forms.MessageBox.Show(" ");
  listBox1.Items.Add(
    PerformanceSampling.GetSampleDurationText(TEST_NUMBER));
}
else
{
  System.Windows.Forms.MessageBox.Show(
      "    ");
}

}
