Option Strict On
Public Class GraphicsGlobals

Private Shared s_Player_Bitmap1 As System.Drawing.Bitmap
Private Shared s_Player_Bitmap2 As System.Drawing.Bitmap
Private Shared s_Player_Bitmap3 As System.Drawing.Bitmap
Private Shared s_Player_Bitmap4 As System.Drawing.Bitmap
Private Shared s_colPlayerBitmaps As _
                System.Collections.ArrayList

'---------------------------------------------------
'  
'---------------------------------------------------
Public Shared Sub g_PlayerBitmapsCollection_CleanUp()

  '     ,       
  If (s_colPlayerBitmaps Is Nothing) Then Return

  '      
  '    
  s_Player_Bitmap1.Dispose()
  s_Player_Bitmap2.Dispose()
  s_Player_Bitmap3.Dispose()
  s_Player_Bitmap4.Dispose()

  '    ,    
  '   
  s_Player_Bitmap1 = Nothing
  s_Player_Bitmap2 = Nothing
  s_Player_Bitmap3 = Nothing
  s_Player_Bitmap4 = Nothing

  '  
  s_colPlayerBitmaps = Nothing
End Sub

'---------------------------------------------------
':   
'---------------------------------------------------
Public Shared Function g_PlayerBitmapsCollection() _
                      As System.Collections.ArrayList
  '---------------------------------------------------------------
  '   ,    
  '---------------------------------------------------------------
  If Not (s_colPlayerBitmaps Is Nothing) Then
      Return s_colPlayerBitmaps
  End If

  '       
  Dim thisAssembly As System.Reflection.Assembly = _
    System.Reflection.Assembly.GetExecutingAssembly()

  Dim thisAssemblyName As System.Reflection.AssemblyName = _
    thisAssembly.GetName()

  Dim assemblyName As String = thisAssemblyName.Name

  ' 
  s_Player_Bitmap1 = New System.Drawing.Bitmap( _
    thisAssembly.GetManifestResourceStream(assemblyName _
    + ".Hank_RightRun1.bmp"))

  s_Player_Bitmap2 = New System.Drawing.Bitmap( _
    thisAssembly.GetManifestResourceStream(assemblyName + _
    ".Hank_RightRun2.bmp"))

  s_Player_Bitmap3 = New System.Drawing.Bitmap( _
    thisAssembly.GetManifestResourceStream(assemblyName + _
    ".Hank_LeftRun1.bmp"))

  s_Player_Bitmap4 = New System.Drawing.Bitmap( _
    thisAssembly.GetManifestResourceStream(assemblyName + _
    ".Hank_LeftRun2.bmp"))


  '   
  s_colPlayerBitmaps = New System.Collections.ArrayList
  s_colPlayerBitmaps.Add(s_Player_Bitmap1)
  s_colPlayerBitmaps.Add(s_Player_Bitmap2)

  s_colPlayerBitmaps.Add(s_Player_Bitmap3)
  s_colPlayerBitmaps.Add(s_Player_Bitmap4)

  ' 
  Return s_colPlayerBitmaps
End Function


Private Shared s_blackPen As System.Drawing.Pen
Private Shared s_whitePen As System.Drawing.Pen
Private Shared s_ImageAttribute As _
          System.Drawing.Imaging.ImageAttributes

Private Shared s_boldFont As System.Drawing.Font

'------------------------------------------------
'     
',    
'------------------------------------------------
Private Shared Sub g_CleanUpDrawingResources()

  '    ,   
  If Not (s_blackPen Is Nothing) Then
    s_blackPen.Dispose()
    s_blackPen = Nothing
  End If

  '    ,   
  If Not (s_whitePen Is Nothing) Then
    s_whitePen.Dispose()
    s_whitePen = Nothing
  End If

  '    ImageAttribute,   .
  '.  Dispose()     ,
  '     
  If Not (s_ImageAttribute Is Nothing) Then
    s_ImageAttribute = Nothing
  End If

  '    ,   
  If Not (s_boldFont Is Nothing) Then
    s_boldFont.Dispose()
    s_boldFont = Nothing
  End If
End Sub

'-----------------------------------------
'    
'  ,   -
'-----------------------------------------
Private Shared Function g_GetBlackPen() As System.Drawing.Pen

  '    ,  
  If (s_blackPen Is Nothing) Then
    s_blackPen = New System.Drawing.Pen( _
      System.Drawing.Color.Black)
  End If

  '  
  Return s_blackPen
End Function

'----------------------------------------
'    
'  ,   -
'----------------------------------------
Private Shared Function g_GetWhitePen() As System.Drawing.Pen

  '    ,  
  If (s_whitePen Is Nothing) Then
    s_whitePen = New System.Drawing.Pen( _
      System.Drawing.Color.White)
  End If

  '  
  Return s_whitePen
End Function

'-----------------------------------------------
'    
'  ,   -
'-----------------------------------------------
Private Shared Function g_GetBoldFont() As System.Drawing.Font
  '    ,  
  If (s_boldFont Is Nothing) Then
    s_boldFont = New System.Drawing.Font( _
      System.Drawing.FontFamily.GenericSerif, _
      10, System.Drawing.FontStyle.Bold)
  End If

  '   
  Return s_boldFont
End Function

'-----------------------------------------------------
'    
'   -  imageAttributes,
'      
'-----------------------------------------------------
Private Shared Function g_GetTransparencyImageAttribute() As _
          System.Drawing.Imaging.ImageAttributes

  '   ,  
  If (s_ImageAttribute Is Nothing) Then

    '  
    s_ImageAttribute = _
      New System.Drawing.Imaging.ImageAttributes

    s_ImageAttribute.SetColorKey(System.Drawing.Color.White, _
      System.Drawing.Color.White)
  End If

  ' 
  Return s_ImageAttribute
End Function
End Class
