Option Strict On
Imports System
Public Class ThreadExecuteTask

'  
Public Enum ProcessingState
  '-------------------
  ' 
  '-------------------
  '  
  notYetStarted

  '-----------------
  ' 
  '-----------------
  '   
  waitingToStartAsync
  '    
  running
  '   
  requestAbort
  '--------------------
  ' 
  '--------------------
  ' :   
  ' 
  done
  ' :   
  '  
  aborted
End Enum

Private m_processingState As ProcessingState

Public Delegate Sub ExecuteMeOnAnotherThread(ByVal _
    checkForAborts As ThreadExecuteTask)

Private m_CallFunction As ExecuteMeOnAnotherThread
Private m_useForStateMachineLock As Object


Public Sub New(ByVal functionToCall As ExecuteMeOnAnotherThread)
  ' ,       
  '  
  m_useForStateMachineLock = New Object

  '    
  m_processingState = ProcessingState.notYetStarted

  ' ,   
  '  
  m_CallFunction = functionToCall

  '----------------------------------------------------------
  '         :
  ' this.ThreadStartPoint()
  '----------------------------------------------------------
  Dim threadStart As System.Threading.ThreadStart
  threadStart = _
    New System.Threading.ThreadStart(AddressOf ThreadStartPoint)

  Dim newThread As System.Threading.Thread
  newThread = New System.Threading.Thread(threadStart)

  '     (  
  '     ,    !)
  setProcessingState(ProcessingState.waitingToStartAsync)

  '         
  newThread.Start()
  '  ,   
End Sub

'-------------------------------------------------------
'    ,  
'   
'-------------------------------------------------------
Private Sub ThreadStartPoint()
  '  ,   
  '   !
  setProcessingState(ProcessingState.running)

  '          
  ',      ,     
  '  
  m_CallFunction(Me)

  '    ,    ,
  '    
  If (m_processingState <> ProcessingState.aborted) Then
        '  
    setProcessingState(ProcessingState.done)
  End If

  '  ...
End Sub

'--------------------------------------------------
' 
'--------------------------------------------------
Public Sub setProcessingState(ByVal nextState As _
                                  ProcessingState)
  '          
  '   
  SyncLock (m_useForStateMachineLock)
    '        
    '    
    If (m_processingState = nextState) Then
            Return
    End If

    '-----------------------------------------------------------
    '  , 
    '    ,   
    ' ,   
    '-----------------------------------------------------------
    If ((m_processingState = ProcessingState.aborted) _
      OrElse (m_processingState = ProcessingState.done)) Then
            Return
    End If

    '     
    Select Case (nextState)
            Case ProcessingState.notYetStarted
        Throw New Exception _
          ("   'notYetStarted' ")

    Case ProcessingState.waitingToStartAsync
      If (m_processingState <> ProcessingState.notYetStarted) _
      Then
        Throw New Exception("  ")
      End If

    Case ProcessingState.running
      If (m_processingState <> _
          ProcessingState.waitingToStartAsync) Then
        Throw New Exception("  ")
      End If

    Case ProcessingState.done
      '     ,   . 
      '     ,   
      ' ,        
      If ((m_processingState <> ProcessingState.running) _
        AndAlso _
      (m_processingState <> ProcessingState.requestAbort)) Then
          Throw New Exception("  ")
      End If

      Case ProcessingState.aborted
        If (m_processingState <> _
          ProcessingState.requestAbort) Then
          Throw New Exception("  ")
        End If
    End Select

    '  
    m_processingState = nextState
  End SyncLock
End Sub

Public ReadOnly Property State() As ProcessingState
    Get
      Dim currentState As ProcessingState
       '   / 
        SyncLock (m_useForStateMachineLock)
          currentState = m_processingState
        End SyncLock
        Return currentState
  End Get
End Property
End Class
