using System;
public class FindNextPrimeNumber
{
//  
public enum ProcessingState
{
  notYetStarted,
  waitingToStartAsync,
  lookingForPrime,
  foundPrime,
  requestAbort,
  aborted
}

long m_startPoint;
long m_NextHighestPrime;

//    ?
long m_comparisonsSoFar;
//       ?
long m_CurrentNumberBeingExamined;
//      
public void getExecutionProgressInfo(
              out long numberCalculationsSoFar, 
              out long currentItemBeingLookedAt)
{

  //.        , 
  //         
  // .    m_comparisonsSoFar
  // m_CurrentNumberBeingExamined   
  //  ,    
  // /    "",
  //   ""  
  lock(this)
  {
    numberCalculationsSoFar = m_comparisonsSoFar;
    currentItemBeingLookedAt = m_CurrentNumberBeingExamined;
  }

}

ProcessingState m_processingState;
//--------------------------------------------------
//   
//--------------------------------------------------
public void setProcessingState(ProcessingState nextState)
{
  //------------------------------------------------------
  //  , 
  //    ,  
  //  ,   
  //------------------------------------------------------

  if   ((m_processingState == ProcessingState.aborted)
    ||  (m_processingState == ProcessingState.foundPrime))
  {
    return;
  }

  //  
  m_processingState = nextState;
}

public ProcessingState getProcessingState
{
  get {return m_processingState;}
}

//---------------------------------------------------
//  
//---------------------------------------------------
public long getPrime()
{
  if (m_processingState != ProcessingState.foundPrime)
  {
    throw new Exception("    !");
  }
  return m_NextHighestPrime;

}

// 
public FindNextPrimeNumber(long startPoint)
{
  setProcessingState(ProcessingState.notYetStarted);
  m_startPoint = startPoint;
}

//-----------------------------------------------------------
//   ,     
// "findNextHighestPrime()" 
//-----------------------------------------------------------
public void findNextHighestPrime_Async()
{
  System.Threading.ThreadStart threadStart;
  threadStart = 
    new System.Threading.ThreadStart(findNextHighestPrime);

  System.Threading.Thread newThread;
  newThread = new System.Threading.Thread(threadStart);

  //  ,   
  setProcessingState(ProcessingState.waitingToStartAsync);
  newThread.Start();
}

//-------------------------------------------------------------
//  .     
//      ,   
//    :
// (a)    
// (b)   (   )  
//       
//-------------------------------------------------------------
public void findNextHighestPrime()
{
  //    ,  
  //   
  if(m_processingState == ProcessingState.requestAbort)
  {
    goto finished_looking;
  }

  //  ,   
  setProcessingState(ProcessingState.lookingForPrime);

  long currentItem;
  //,    
  if ((m_startPoint & 1) == 1)
  {
    //  ,      
    currentItem = m_startPoint + 2;
  }
  else
  {
    //  ,       
    currentItem = m_startPoint + 1;
  }

  //    
  while(m_processingState  == ProcessingState.lookingForPrime)
  {
    //      
    if(isItemPrime(currentItem) == true)
    {
      m_NextHighestPrime =  currentItem;
      // 
      setProcessingState(ProcessingState.foundPrime);
    }

    currentItem = currentItem  + 2;
  }

  finished_looking:
    //.        
    //  ,     
    //   

    //    , 
    //,    
    if (m_processingState == ProcessingState.requestAbort)
    {
      setProcessingState(ProcessingState.aborted);
    }
}

// ,  , 
//  
private bool isItemPrime(long potentialPrime)
{
  //  - , ,    
  if ((potentialPrime & 1) == 0)
  {
    return false;
  }

  //    ,     
  //    
  long end_point_of_search;
  end_point_of_search = (long) System.Math.Sqrt(potentialPrime) + 1;

  long current_test_item = 3;
  while(current_test_item <= end_point_of_search )
  {
    //---------------------------------------------------------
    //,      !
    //---------------------------------------------------------
    if (m_processingState != ProcessingState.lookingForPrime)
    {
      return false;
    }

    //    , 
    //,    
    if(potentialPrime % current_test_item == 0)
    {
      return false;
    }

    //   
    current_test_item  = current_test_item  + 2;
    //------------------------------------------------------
    //   
    //------------------------------------------------------
    //.        , 
    //         
    // .    m_comparisonsSoFar
    // m_CurrentNumberBeingExamined   
    //  ,    
    // /    "",
    //   ""  
    lock(this)
    {
      m_CurrentNumberBeingExamined = potentialPrime;      
      m_comparisonsSoFar++;
    }
  }

  //  
  return true;
} //  
} // 
