Option Strict On
Imports System
Public Class FindNextPrimeNumber
'  
Public Enum ProcessingState
  notYetStarted
  waitingToStartAsync
  lookingForPrime
  foundPrime
  requestAbort
  aborted
End Enum

Private m_startPoint As Long
Private m_NextHighestPrime As Long

'    ?
Private m_comparisonsSoFar As Long
'       ?
Private m_CurrentNumberBeingExamined As Long
'      
Public Sub getExecutionProgressInfo( _
              ByRef numberCalculationsSoFar As Long, _
              ByRef currentItemBeingLookedAt As Long)

  '.        , 
  '         
  ' .    m_comparisonsSoFar
  ' m_CurrentNumberBeingExamined   
  '  ,    
  ' /    "",
  '   ""  
  SyncLock (Me)
      numberCalculationsSoFar = m_comparisonsSoFar
    currentItemBeingLookedAt = m_CurrentNumberBeingExamined
  End SyncLock

End Sub

Private m_processingState As ProcessingState
'--------------------------------------------------
'  
'--------------------------------------------------
Public Sub setProcessingState(ByVal nextState As _
                                    ProcessingState)
  '------------------------------------------------------
  '  , 
  '    ,  
  '  ,   
  '------------------------------------------------------

  If ((m_processingState = ProcessingState.aborted) _
    OrElse (m_processingState = ProcessingState.foundPrime)) _
  Then
      Return
  End If

  '  
  m_processingState = nextState
End Sub

Public ReadOnly Property getProcessingState() As ProcessingState
  Get
    Return m_processingState
  End Get
End Property

'---------------------------------------------------
'  
'---------------------------------------------------
Public Function getPrime() As Long
  If (m_processingState <> ProcessingState.foundPrime) Then
      Throw New Exception("    !")
  End If
  Return m_NextHighestPrime

End Function

' 
Public Sub New(ByVal startPoint As Long)
  setProcessingState(ProcessingState.notYetStarted)
  m_startPoint = startPoint
End Sub

'------------------------------------------------------------
'   ,     
'findNextHighestPrime()
'------------------------------------------------------------
Public Sub findNextHighestPrime_Async()
  Dim threadStart As System.Threading.ThreadStart
  threadStart = _
    New System.Threading.ThreadStart(AddressOf _
            findNextHighestPrime)

  Dim newThread As System.Threading.Thread
  newThread = New System.Threading.Thread(threadStart)

  '  ,   
  setProcessingState(ProcessingState.waitingToStartAsync)
  newThread.Start()
End Sub

'-------------------------------------------------------------
'  .     
'      ,   
'    :
' (a)    
' (b)   (   )  
'       
'-------------------------------------------------------------
Public Sub findNextHighestPrime()
  '    ,   
  '  
  If (m_processingState = ProcessingState.requestAbort) Then
      GoTo finished_looking
  End If

  '  ,   
  setProcessingState(ProcessingState.lookingForPrime)

  Dim currentItem As Long
  ',    
  If ((m_startPoint And 1) = 1) Then
      '  ,      
    currentItem = m_startPoint + 2
  Else
      '  ,      
    currentItem = m_startPoint + 1
  End If

  '    
  While (m_processingState = ProcessingState.lookingForPrime)
      '    ,  
    If (isItemPrime(currentItem) = True) Then
          m_NextHighestPrime = currentItem
      ' 
      setProcessingState(ProcessingState.foundPrime)
    End If

    currentItem = currentItem + 2
  End While

finished_looking:
    '.        
    '  ,     
    '   

    '    , 
    ',    
    If (m_processingState = ProcessingState.requestAbort) Then
          setProcessingState(ProcessingState.aborted)
    End If
End Sub

' ,  , 
'  
Private Function isItemPrime(ByVal potentialPrime _
                              As Long) As Boolean
  '  - , ,    
  If ((potentialPrime And 1) = 0) Then
      Return False
  End If

  '    ,      
  '   
  Dim end_point_of_search As Long
  end_point_of_search = _
      CLng(System.Math.Sqrt(potentialPrime)) + 1

  Dim current_test_item As Long = 3
  While (current_test_item <= end_point_of_search)
    '---------------------------------------------------------
    ',      !
    '---------------------------------------------------------
    If (m_processingState <> ProcessingState.lookingForPrime) _
    Then
          Return False
    End If

    '    , 
    ',    
    If (potentialPrime Mod current_test_item = 0) Then
          Return False
    End If

    '   
    current_test_item = current_test_item + 2
    '------------------------------------------------------
    '   
    '------------------------------------------------------
    '.        , 
    '         
    ' .    m_comparisonsSoFar
    ' m_CurrentNumberBeingExamined   
    '  ,    
    ' /    "",
    '   ""  
    SyncLock (Me)
          m_CurrentNumberBeingExamined = potentialPrime
      m_comparisonsSoFar = m_comparisonsSoFar + 1
    End SyncLock
  End While

  '  
  Return True
End Function
End Class	
